/*
 * global.scss
 * emilien <emilien@emilien-pc>, 2021
 */

@import './reset.scss';
@import './colors.scss';
@import './mixins.scss';
@import './include-media.scss';
@import './icons.scss';

:root {
	--main-background-color: #{clr("gray-900")};
	--main-font-color: white;
	--secondary-font-color: #{clr("gray-600")};
	 @each $name, $value in $colors {
		 --#{$name}: #{$value};
	 }
	@include media('<sm') {
		font-size: 14px;
	}

	@include media('<sm') {
		font-size: 14px;
	}
}

@each $name, $value in $colors {
	.#{$name} { --current-color: #{$value}; }
}

.bg { background-color: var(--current-color); }
.fg { color: var(--current-color); }

body {
	font-family: -apple-system, -apple-system-font, BlinkMacSystemFont, 'Roboto', 'Segoe UI', 'Oxygen', 'Fira Sans',  'Ubuntu', 'Cantarell', 'Droid Sans', 'Helvetica Neue', sans-serif;
	background-color: var(--main-background-color);
	min-height: vh(100);
	min-height: -webkit-fill-available;
	color: var(--main-font-color);
	-webkit-font-smoothing: antialiased;
	-moz-osx-font-smoothing: grayscale;
}

.no-decoration {
	text-decoration: none;
}

////////// TEXT SPECIFIC CLASSES
h1 {
	@include fsize(4.5, 6.125);
	@include exbold;
}

h2 {
	@include fsize(3, 4);
	@include exbold;
}

h3 {
	@include fsize(2.5, 3.375);
	@include exbold;
}

h4 {
	@include fsize(1.75, 2.5);
	@include exbold;
}

h5 {
	@include fsize(1.5, 2);
	@include smbold;
}

h6 {
	@include fsize(1.25, 1.875);
	@include medium;
}

a {
	--current-color: #{clr("blue")};
	color: var(--current-color);
	cursor: pointer;
	text-decoration: none;

	&.lg {
		@include fsize(1.25, 1.875);
		@include medium;
	}

	&.md {
		@include fsize(1.125, 2);
		@include medium;
	}

	&.sm {
		@include fsize(0.875, 1.5);
		@include medium;
	}
}

.lead {
	color: var(--secondary-font-color);
	&.md {
		@include fsize(1.125, 2);
		font-weight: 400;
	}

	&.sm {
		@include fsize(0.875, 1.5);
		@include medium;
	}

}

.body {
	color: var(--secondary-font-color);
	font-weight: 400;

	&.md { @include fsize(1, 1.625); }
	&.sm { @include fsize(0.875, 1.375); }

	&.bold {
		color: black;
		font-weight: 700;
	}
}

label, .label {
	@include smbold;
	@include fsize(0.875, 1.25);

	&.lg { @include fsize(1.25, 1.875); }
	&.sm { @include fsize(0.75, 1); }
}

////////// STANDARD BUTTON
button:not([class]), .button {
	--current-color: #{clr("blue")}; // Default selected color
	@include fsize(1.125, 2);
	min-width: 12rem;
	width: 100%;
	color: white;
	background-color: var(--current-color);
	font-weight: bold;
	height: 3rem;
	border-radius: 0.5rem;

	&.invert {
		color: var(--current-color);
		background-color: var(--main-bg-color);
	}

	&.sm {
		@include fsize(0.875, 1.5);
		height: 2rem;
		min-width: 10rem;
	}

	&.lg {
		@include fsize(1.25, 1.875);
		height: 4rem;
		min-width: 14rem;
	}

	&:focus {
		outline: none;
	}

	&:active {
		filter: opacity(0.8);
	}
}

////////// FLEX, GRID & TEXT ALIGNMENT
.flex {
	display: flex;

	&.row { flex-direction: row; }
	&.column { flex-direction: column; }

	.justify-end { justify-self: flex-end; }
	.justify-start { justify-self: flex-start; }
}

.grid { display: grid; }

.flex, .grid {
	&.gap-0-5 { gap: 0.5rem; }
	&.gap-1 { gap: 1rem; }
	&.gap-1-5 { gap: 1.5rem; }
	&.gap-2 { gap: 2rem; }

	&.center {
		align-items: center;
		justify-content: center;
	}

	&.center-align { align-items: center; }
	&.center-justify { justify-content: center; }

}


.center-text { text-align: center; }
.right-text { text-align: right; }


// WIDTH & HEIGHT SPECIFICS

.vh-10 { height: vh(10); }
.vh-20 { height: vh(20); }
.vh-30 { height: vh(30); }
.vh-40 { height: vh(40); }
.vh-50 { height: vh(50); }
.vh-60 { height: vh(60); }
.vh-70 { height: vh(70); }
.vh-80 { height: vh(80); }
.vh-90 { height: vh(90); }
.vh-100 { height: vh(100); }

.vw-100 { width: 100vw; }

.h-100 { height: 100%; }

.w-100 { width: 100%; }
.w-100 { width: 100%; }

.ew-xsm { width: 100%; max-width: $xsm }
.ew-sm { width: 100%; max-width: $sm }
.ew-md { width: 100%; max-width: $md }
.ew-lg { width: 100%; max-width: $lg }
.ew-xl { width: 100%; max-width: $xl }
.ew-xxl { width: 100%; max-width: $xl }

.mt-0-5 { margin-top: 0.5rem }
.mb-0-5 { margin-bottom: 0.5rem }
.mt-1 { margin-top: 1rem }
.mb-1 { margin-bottom: 1rem }
.mt-2 { margin-top: 2rem }
.mt-3 { margin-top: 3rem }
.mt-4 { margin-top: 4rem }
.mb-2 { margin-bottom: 2rem }
.ml-auto { margin-left: auto }

.pt-0-5 { padding-top: 0.5rem }
.pb-0-5 { padding-bottom: 0.5rem }
.pt-1 {  padding-top: 1rem }
.pb-1 {  padding-bottom: 1rem }
.pt-2 {  padding-top: 2rem }
.pb-2 {  padding-bottom: 2rem }

.p-5rv { padding: 5vh 5vw; }

.scroll-y-auto { overflow-y: auto }
